#<profile4xi profile = "10" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "reduce_ctype4xi.py">
#<abstract4xi abstract = "providing function reduce_ctype4xi"/>
#<refer4xi reference = "sharedctypes.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = ['reduce_ctype4xi']  
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import sys
import ctypes
import weakref
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import ctypes
    import weakref         
except:
    pass

#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.sharedctypes import reduce_ctype 
except:
    print("reduce_ctype4xi.py: *** failed in from multiprocessing.sharedctypes import reduce_ctype ***")   
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from assert_spawning4xi import assert_spawning4xi
from examine4xi import examine4xi
from rebuild_ctype4xi import rebuild_ctype4xi
from print4xi import print4xi
from time4xi import time4xi
#"
#/>

 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "reduce_ctype4xi" usage = "
#   sharedctypes.py                              
#       rebuild_ctype(type_, wrapper, length):
#           ForkingPickler.register(type_, reduce_ctype4xi)
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def reduce_ctype4xi(obj):
    '''
    reduce_ctype4xi function in sharedctypes.py rebuild_ctype function: ForkingPickler.register(type_, reduce_ctype4xi)
    '''
    # -----------------------------------------------------------------------------------------    
    # (Step 1/3)
    # -----------------------------------------------------------------------------------------     
    class2print = "reduce_ctype4xi"
    method2print = "reduce_ctype4xi"

    message2print = "{started" + "; reduce-ctype4xi-started: " + str(reduce_ctype4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
        
    message2print = "{passed" + "; object-passed-to-reduce-ctype4xi: " + str(obj) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    if examine4xi(class2print, method2print):  
    
        # -------------------------------------------------------------------------------------    
        # StepOriginal
        # -------------------------------------------------------------------------------------             
        message2print = "{(StepOriginal) performing" + "; reduce_ctype-performing-by-reduce_ctype4xi: " + str(reduce_ctype) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
            
                         
        return reduce_ctype(obj)
        
    else:                 
           
        message2print = "{(Step 1/3a) passing" + "; object-passing-to-assert-spawning4xi-by-reduce-ctype4xi: " + str(obj) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
            
                
        assert_spawning4xi(obj)
        
        message2print = "{(Step 1/3b) performed" + "; assert-spawning4xi-performed-by-reduce-ctype4xi: " + str(assert_spawning4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                 
         
        
        if isinstance(obj, ctypes.Array):
        
            # -------------------------------------------------------------------------------------    
            # (Step 2/3)
            # -------------------------------------------------------------------------------------      
                 
            message2print = "{(Step 2/3a) passing" + "; object-type-passing-to-rebuild_ctype4xi-by-reduce-ctype4xi: " + str(obj._type_) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)   
            
                   
            message2print = "{(Step 2/3b) passing" + "; object-wrapper-passing-to-rebuild_ctype4xi-by-reduce-ctype4xi: " + str(obj._wrapper) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)   
                      
                   
            message2print = "{(Step 2/3c) passing" + "; object-length-passing-to-rebuild_ctype4xi-by-reduce-ctype4xi: " + str(obj._length_) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)   
    
                     
            message2print = "{(Step 2/3d) returning" + "; rebuild-ctype4xi-function-returning-by-reduce-ctype4xi: " + str(rebuild_ctype4xi) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
                         
                   
            return rebuild_ctype4xi, (obj._type_, obj._wrapper, obj._length_)
        else:
        
            # -------------------------------------------------------------------------------------    
            # (Step 3/3)
            # -------------------------------------------------------------------------------------      
            
    
            
            message2print = "{(Step 3/3a) passing" + "; type-object-passing-to-rebuild_ctype4xi-by-reduce-ctype4xi: " + str(type(obj)) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)   
            
            message2print = "{(Step 3/3a) passing" + "; wrapper-object-passing-to-rebuild_ctype4xi-by-reduce-ctype4xi: " + str(obj._wrapper) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)   
                     
            message2print = "{(Step 3/3a) returning" + "; rebuild-ctype4xi-function-returning-by-reduce-ctype4xi: " + str(rebuild_ctype4xi) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
                    
            return rebuild_ctype4xi, (type(obj), obj._wrapper, None)
         
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------        
           
        
#</function4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of reduce_ctype4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
